;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; various workspaces used day to day

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; load most recent auto save
(defun kmn/workspace-load-auto ()
  (interactive)
  (persp-load-state-from-file "persp-auto-save")
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; save the current workspace to `latest` filename
(defun kmn/workspace-save-latest ()
  (interactive)
  (persp-save-state-to-file "latest")
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; load `latest` file name to current workspace
(defun kmn/workspace-load-latest ()
  (interactive)
  (persp-load-state-from-file  "latest")
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; org-mode workspace
(defun kmn/workspace-org ()
  (interactive)
  ; front load org-agenda so it doesnt reshuffle the frame layout on us
  (org-agenda nil "r")
  ; start with fresh frame
  (delete-other-windows)
  ; show kmn's slipbox
  (find-file "~/org/orgzly/_slipbox.org")
  ; split window for additional file to show
  (split-window-below)
  (next-multiframe-window)
  ; show kmn health notes/data tracker
  (find-file "~/org/health/health_mike.org")
  ; put agenda in top side window (works around org-mode limitations
  (kmn/org-agenda-on-top)
  (next-multiframe-window)
  (goto-char 0)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; empty code workspace
(defun kmn/workspace-code-empty (&optional dir_path)
  (interactive)
  (delete-other-windows)
  (kmn/kill-other-buffers)
  (kmn/show-buffer-scratch)
  ; show dired at `~` in left side window
  (kmn/dired-directory-on-left dir_path)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; emacs config development
(defun kmn/workspace-code-emacs-config()
  (interactive)
  (kmn/workspace-code-empty "~/.emacs.d.profiles")
  (find-file "~/.emacs.d.profiles/org/init.el")
  (find-file "~/.emacs.d.profiles/code/init.el")
  (find-file "~/.emacs.d.profiles/common/_global.el")
  (find-file "~/.emacs.d.profiles/common/generic_functions.el")
  (find-file "~/.emacs.d.profiles/common/workspaces.el")
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hugo development
(defun kmn/workspace-code-generic()
  (interactive)
  (kmn/workspace-code-empty "~/src")
)
